Attribute VB_Name = "modLineDraw"
'Option Explicit
Dim dx, dy As Integer
Dim m As Double
Dim x, y As Integer
Dim i As Integer

Public Sub A1Draw()
Dim double_y As Double
      
    initPaint
    paintPixel
    
    For x = x0 To x1
        double_y = m * x + y0
        y = Round(double_y)
    paintPixel
    Next x
    
End Sub

Public Sub A2Draw()
Dim double_y As Double
    
    initPaint
    paintPixel
    
    i = 1
    For x = x0 To x1
        double_y = y0 + (i * m)
        y = Round(double_y)
        i = i + 1
    
    paintPixel
    Next x
End Sub


Public Sub A3Draw()
Dim twice_d As Integer
    twice_d = 2 * dy - dx
       
    initPaint
    paintPixel
    
    For x = x0 To x1
        If (twice_d >= 0) Then
            'Choose NE
            y = y + 1
            twice_d = twice_d + 2 * (dy - dx)
        Else
            'Choose E
            y = y
            twice_d = twice_d + 2 * dy
        End If
    
    paintPixel
    Next x
End Sub

Private Sub initPaint()
    dx = x1 - x0
    dy = y1 - y0
    m = dy / dx
    If (m < 0 Or m > 1) Then
        MsgBox ("Value of m < 0 or > 1" & Chr(13) & "May Not Work Properly!!!")
    End If
    x = x0
    y = y0
End Sub

Private Sub paintPixel()
    Select Case lineWidth
        Case 1: frmLineDraw.picArea.PSet (x, frmLineDraw.picArea.ScaleHeight - y), frmLineDraw.picArea.ForeColor
        Case Is > 1:
            frmLineDraw.picArea.PSet (x, frmLineDraw.picArea.ScaleHeight - y), frmLineDraw.picArea.ForeColor
            thickPaint
        Case Default:
            MsgBox ("Invalid Line Width")
    End Select
End Sub

Private Sub thickPaint()
    Select Case (Primitive)
        Case "P1": pixelReplication
        Case "P2": rectangularPen
    End Select
End Sub

Private Sub pixelReplication()
Dim above As Integer
    Dim below As Integer
    Dim i, j As Integer
    
    above = Round((lineWidth - 1) / 2)
    below = (lineWidth - 1) - above
    
    If (m <= 1 And m >= 0) Then
    ' for (0 <= theta <= 45)
    'use Column Replication
            For i = 0 To (above - 1)
                frmLineDraw.picArea.PSet (x, frmLineDraw.picArea.ScaleHeight - (y + i + 1)), frmLineDraw.picArea.ForeColor
            Next i
            For j = 0 To (below - 1)
                frmLineDraw.picArea.PSet (x, frmLineDraw.picArea.ScaleHeight - (y - j - 1)), frmLineDraw.picArea.ForeColor
            Next j
    Else
    'for other values of Theta (May not Work all the time)
    'Use Row Replication
            For i = 0 To (above - 1)
                frmLineDraw.picArea.PSet (x + (i + 1), frmLineDraw.picArea.ScaleHeight - y), frmLineDraw.picArea.ForeColor
            Next i
            For j = 0 To (below - 1)
                frmLineDraw.picArea.PSet (x - (j - 1), frmLineDraw.picArea.ScaleHeight - y), frmLineDraw.picArea.ForeColor
            Next j
    End If
End Sub

Private Sub rectangularPen()
    frmLineDraw.picArea.PSet (x - 1, frmLineDraw.picArea.ScaleHeight - y), frmLineDraw.picArea.ForeColor
    frmLineDraw.picArea.PSet (x + 1, frmLineDraw.picArea.ScaleHeight - y), frmLineDraw.picArea.ForeColor
    
    frmLineDraw.picArea.PSet (x, frmLineDraw.picArea.ScaleHeight - (y + 1)), frmLineDraw.picArea.ForeColor
    frmLineDraw.picArea.PSet (x, frmLineDraw.picArea.ScaleHeight - (y - 1)), frmLineDraw.picArea.ForeColor
    
    frmLineDraw.picArea.PSet (x - 1, frmLineDraw.picArea.ScaleHeight - (y + 1)), frmLineDraw.picArea.ForeColor
    frmLineDraw.picArea.PSet (x - 1, frmLineDraw.picArea.ScaleHeight - (y - 1)), frmLineDraw.picArea.ForeColor
    frmLineDraw.picArea.PSet (x + 1, frmLineDraw.picArea.ScaleHeight - (y + 1)), frmLineDraw.picArea.ForeColor
    frmLineDraw.picArea.PSet (x + 1, frmLineDraw.picArea.ScaleHeight - (y - 1)), frmLineDraw.picArea.ForeColor
End Sub

